<?php

/*
* @version	1.0.3
* @package	Simple Editor
* @copyright	2007 OXPUS http://www.oxpus.net
*/

// Include the settings
include('./config.inc');

// Build the global file url
$url = $script_path . $filename . $phpEx;

// Disable some unwanted messages and warnings from the php interpreter
error_reporting(E_ERROR | E_WARNING | E_PARSE); // This will NOT report uninitialized variables

// Initiate various settings
$language = (isset($_GET['lang'])) ? htmlspecialchars(addslashes($_GET['lang'])) : htmlspecialchars(addslashes($_POST['lang']));
$language = (!$language) ? $lang_default : $language;
$mode = (isset($_GET['mode'])) ? htmlspecialchars(addslashes($_GET['mode'])) : htmlspecialchars(addslashes($_POST['mode']));
$confirm = (isset($_GET['confirm'])) ? htmlspecialchars(addslashes($_GET['confirm'])) : htmlspecialchars(addslashes($_POST['confirm']));
$cancel = (isset($_GET['cancel'])) ? htmlspecialchars(addslashes($_GET['cancel'])) : htmlspecialchars(addslashes($_POST['cancel']));
$pass = (isset($_GET['pass'])) ? htmlspecialchars(addslashes($_GET['pass'])) : htmlspecialchars(addslashes($_POST['pass']));
$old_pass = (isset($_POST['old_pass'])) ? htmlspecialchars(addslashes($_POST['old_pass'])) : '';
$new_pass = (isset($_POST['new_pass'])) ? htmlspecialchars(addslashes($_POST['new_pass'])) : '';
$con_pass = (isset($_POST['con_pass'])) ? htmlspecialchars(addslashes($_POST['con_pass'])) : '';
$id = (isset($_GET['id'])) ? intval($_GET['id']) : intval($_POST['id']);
$start = (isset($_GET['start'])) ? intval($_GET['start']) : intval($_POST['start']);
$index = array();
$lang = array();

if (@is_file('./data/pass.dat'))
{
	include('./data/pass.dat');
	$first_password = false;
}
else
{
	$global_password = md5('simple');
	$mode = 'password';
	$first_password = true;
}

// Correct mode on add a page
if ($mode == 'add')
{
	$id = -1;
}

// Action for cancel an event
if ($cancel || ($mode == 'edit' && empty($pass) && $confirm))
{
	$mode = '';
}

// Include the index file
$index_file = './data/index.dat';
if (@is_file($index_file))
{
	include($index_file);
}

// Reset start if it will query to an entry outside the index
$start = ($start > sizeof($index) || $start < 0) ? 0 : $start;

// Include the language file. On default the german language
$lang_file = './lang/' . $language . $phpEx;
if (@is_file($lang_file))
{
	include($lang_file);
}
else
{
	die('No language file found! Please be sure you have upload at least the german lang_file into /lang/.');
}

if ($mode == 'parse' && ($id || $id === 0))
{
	$file_name = $index[$id];

	if (@is_file('./data/'.$file_name.'.dat') && @is_file('./page/'.$file_name.'.htm'))
	{
		header("HTTP/1.1 301 Moved Permanently");
		header("Location: " . $script_path . "page/" . $file_name . ".htm");
		exit;
	}

	$mode = '';
}

if ($mode != 'save' &&
!($mode == 'delete' && $confirm && $pass) &&
!($mode == 'password' && $confirm && $new_pass && $old_pass && $con_pass))
{

?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html dir="ltr">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<meta http-equiv="Content-Style-Type" content="text/css" />

<title><?php echo $lang['Simple_Editor']; ?></title>

</head>

<body>

<?php

// Display the title and the possible languages
echo '<h1>'.$lang['Simple_Editor'].'</h1>'."\n";
echo '<p><a href="'.$url.'?mode=&amp;id=&amp;lang='.$language.'&amp;start='.$start.'">'.$lang['Index'] . '</a>';
echo '&nbsp;&nbsp;&nbsp;<a href="'.$url.'?mode=password&amp;id=&amp;lang='.$language.'&amp;start='.$start.'">'.$lang['Global_password'] . '</a></p>'."\n";

for ($l = 0; $l < sizeof($lang_files); $l++)
{
	if (@is_file('./lang/'.$lang_files[$l].$phpEx))
	{
		if ($lang_files[$l] == $language)
		{
			$lang_output .= '&nbsp;'.$lang_names[$l].'&nbsp;|';
		}
		else
		{
			$lang_output .= '&nbsp;<a href="'.$url.'?mode='.$mode.'&amp;id='.$id.'&amp;lang='.$lang_files[$l].'&amp;start='.$start.'">'.$lang_names[$l] . '</a>&nbsp;|';
		}
	}
}
$lang_output = substr($lang_output, 0, strlen($lang_output) - 1);
echo '<div align="right">'.$lang['Language'].$lang_output.'</div>'."\n";

}

// run the current mode
$redirect = false;
switch ($mode)
{
	case 'delete':

		if ($confirm && $pass)
		{
			$unlink_file = $index[$id];
			include('./data/'.$unlink_file.'.dat');

			if ((md5($pass) == $password) || (md5($pass) == $global_password))
			{
				@unlink('./data/'.$unlink_file.'.dat');
				@unlink('./page/'.$unlink_file.'.htm');

				$data = "<?php\n";
				for ($i = 0; $i <= sizeof($index); $i++)
				{
					if ($i <> $id)
					{
						if ($index[$i] && @is_file('./data/'.$index[$i].'.dat'))
						{
							$data .= '$index['.$i.'] = "'.$index[$i].'";'."\n";
						}
					}
				}
				$data .= "?>";

				@unlink($index_file);
				$fp = fopen($index_file, "w");
				fwrite($fp, $data);
				fclose($fp);
			}

			$redirect = true;
			$mode = '';
			$id = '';
			$confirm = '';
		}
		else
		{
			echo '<div align="center">'.sprintf($lang['Confirm_delete'], $index[$id])."\n";
			echo '<br /><form action="'.$url.'?mode=delete&amp;id='.$id.'&amp;lang='.$language.'&amp;start='.$start.'" method="post">'."\n";
			echo $lang['Password'].': <input type="password" name="pass" size="30" value="" />'."\n";
			echo '<br /><input type="submit" name="confirm" value="'.$lang['Delete'].'" />&nbsp;'."\n";
			echo '<input type="submit" name="cancel" value="'.$lang['Cancel'].'" /></form></div>'."\n";
		}

		break;

	case 'save':

		$page_title = (isset($_GET['page_title'])) ? htmlspecialchars($_GET['page_title']) : htmlspecialchars($_POST['page_title']);
		$page_text = (isset($_GET['page_text'])) ? $_GET['page_text'] : $_POST['page_text'];

		if (empty($pass))
		{
			die($lang['No_password']);
		}

		if ($id === -1)
		{
			$index[] = $page_title;
			$id = sizeof($index);

			if (@is_file('./data/'.$page_title.'.dat'))
			{
				$page_title .= "#$id";
				$index[$id--] = $page_title;
			}
		}
		else
		{
			if ($page_title <> $index[$id])
			{
				@unlink('./data/'.$index[$id].'.dat');
			}
			$index[$id] = $page_title;
		}

		$data = "<?php\n";
		for ($i = 0; $i <= sizeof($index); $i++)
		{
			if ($index[$i])
			{
				$data .= '$index[] = "'.$index[$i].'";'."\n";
			}
		}
		$data .= "?>";

		@unlink($index_file);
		$fp = fopen($index_file, "w");
		fwrite($fp, $data);
		fclose($fp);

		$html_content = stripslashes($page_text);
		$page_text = "<?php\n".'$page_text = "'.htmlspecialchars($page_text).'";'."\n".'$password = "'.md5($pass).'";'."\n?>";

		@unlink('./data/'.$page_title.'.dat');
		$fp = fopen('./data/'.$page_title.'.dat', "w");
		fwrite($fp, $page_text);
		fclose($fp);

		@unlink('./page/'.$page_title.'.htm');
		$fp = fopen('./page/'.$page_title.'.htm', "w");
		fwrite($fp, $html_content);
		fclose($fp);

		$id = 0;

		$redirect = true;

		break;

	case 'add':
	case 'edit':

		$page_edit = '';

		if ($mode == 'edit')
		{
			$page_file = $index[$id];

			if ($confirm && $pass && @is_file('./data/'.$page_file.'.dat'))
			{
				include('./data/'.$page_file.'.dat');

				if ((md5($pass) == $password) || (md5($pass) == $global_password))
				{
					$page_title = $index[$id];
					$page_edit = true;
				}
				else
				{
					$page_title = $pass = $page_text = $confirm = $mode = $id = '';
					echo '<div align="center"><b>'.$lang['Wrong_password'].'</b></div>';
				}
			}
			else
			{
				echo '<div align="center"><form action="'.$url.'?mode=edit&amp;id='.$id.'&amp;lang='.$language.'&amp;start='.$start.'" method="post">'."\n";
				echo '<br />'.$lang['Password'].': <input type="password" name="pass" size="30" value="" />'."\n";
				echo '<br /><br /><input type="submit" name="confirm" value="'.$lang['Edit'].'" />&nbsp;'."\n";
				echo '<input type="submit" name="cancel" value="'.$lang['Cancel'].'" />'."\n";
				echo '</form></div>'."\n";
			}
		}
		else
		{
			$page_title = '';
			$page_text = '';
			$pass = '';
			$id = '-1';
			$page_edit = true;
		}

		if ($page_edit)
		{
			echo '<form action="'.$url.'?mode=save&amp;id='.$id.'&amp;lang='.$language.'&amp;start='.$start.'" method="post">'."\n";
			echo '<br />'.$lang['Title'].':<br /><input type="text" size="40" maxlength="40" name="page_title" value="'.$page_title.'" />'."\n";
			echo '<br /><br />'.$lang['Content'].':<br /><textarea cols="100" rows="20" name="page_text">'.stripslashes($page_text).'</textarea>'."\n";
			echo '<br /><br /><u>'.$lang['Confirm'].':</u><br /><input type="password" name="pass" size="40" maxlength="40" value="" />'."\n";
			echo '&nbsp;&nbsp;<input type="submit" name="submit" value="'.$lang['Submit'].'" />&nbsp;'."\n";
			echo '&nbsp;&nbsp;<input type="submit" name="cancel" value="'.$lang['Cancel'].'" /></form>'."\n";
		}

		break;

	case 'view':

		$page_title = $index[$id];
		include('./data/'.$page_title.'.dat');

		echo '<hr /><div align="center"><b>'.$page_title.'</b></div>'."\n";
		echo '<p style="border: 1px dotted; padding: 3px;">'.str_replace("\n", "\n<br />\n", stripslashes($page_text)).'</p><hr />'."\n";
		echo '<div align="center">[<a href="'.$url.'?mode=edit&amp;id='.$id.'&amp;lang='.$language.'&amp;start='.$start.'">'.$lang['Edit'].'</a>]&nbsp;'."\n";
		echo '[<a href="'.$url.'?mode=delete&amp;id='.$id.'&amp;lang='.$language.'&amp;start='.$start.'">'.$lang['Delete'].'</a>]&nbsp;'."\n";
		echo '[<a href="'.$url.'?mode=parse&amp;id='.$id.'" target="_blank">'.$lang['Parse'].'</a>]</div>'."\n";
		
		break;

	case 'password':

		if ($confirm && $new_pass && $con_pass && $old_pass)
		{
			if (md5($old_pass) == $global_password && $new_pass == $con_pass)
			{
				$global_password = "<?php\n";
				$global_password .= '$global_password = "'.md5($new_pass).'";'."\n";
				$global_password .= "?>";

				@unlink('./data/pass.dat');
				$fp = fopen('./data/pass.dat', "w");
				fwrite($fp, $global_password);
				fclose($fp);

				echo '<h1>'.$lang['Simple_Editor'].'</h1>'."\n";
				echo '<p><a href="'.$url.'?mode=&amp;id=&amp;lang='.$language.'&amp;start='.$start.'">'.$lang['Index'] . '</a></p>';
				echo '<br /><b>'.$lang['Global_password_saved'].'</b>'."\n";
				exit;
			}
			else
			{
				echo '<h1>'.$lang['Simple_Editor'].'</h1>'."\n";
				echo '<p><a href="'.$url.'?mode=&amp;id=&amp;lang='.$language.'&amp;start='.$start.'">'.$lang['Index'] . '</a>';
				echo '&nbsp;&nbsp;&nbsp;<a href="'.$url.'?mode=password&amp;id=&amp;lang='.$language.'&amp;start='.$start.'">'.$lang['Global_password'] . '</a></p>'."\n";
				echo '<br /><b>'.$lang['Wrong_global_password'].'</b>'."\n";
				exit;
			}
		}

		if (empty($redirect))
		{
			echo '<div align="center">'.$lang['New_global_password'].'</div>'."\n";

			if ($first_password)
			{
				echo '<br /><div align="center">'.$lang['First_new_global_password'].'</div>'."\n";
			}

			echo '<div>'."\n";
			echo '<form action="'.$url.'?mode=password&amp;id=&amp;lang='.$language.'&amp;start=" method="post">'."\n";
			echo '<br />'.$lang['Global_password_old'].':<br /><input type="password" size="40" maxlength="40" name="old_pass" value="" />'."\n";
			echo '<br /><br />'.$lang['Global_password_new'].':<br /><input type="password" size="40" maxlength="40" name="new_pass" value="" />'."\n";
			echo '<br />'.$lang['Global_password_con'].':<br /><input type="password" size="40" maxlength="40" name="con_pass" value="" />'."\n";
			echo '<br /><br /><input type="submit" name="confirm" value="'.$lang['Submit'].'" />&nbsp;'."\n";
			echo '&nbsp;&nbsp;<input type="submit" name="cancel" value="'.$lang['Cancel'].'" /></form></div>'."\n";
		}

		break;		

	default:

		// Build the index, if found
		if (sizeof($index))
		{
			$index_keys = array_keys($index);
			$last_index_key = $index_keys[sizeof($index)-1];

			$j = $start + $page_rows;
			$j = ($j > $last_index_key) ? $last_index_key : $j;
			$m = 0;

			for ($i = $start; $i <= $j; $i++)
			{
				if ($index[$i] && is_file('./data/'.$index[$i].'.dat'))
				{
					echo '<p><a href="'.$url.'?mode=view&amp;id='.$i.'&amp;lang='.$language.'&amp;start='.$start.'"><b>'.$index[$i].'</b></a>&nbsp;&nbsp;&nbsp;'."\n";
					echo '[<a href="'.$url.'?mode=edit&amp;id='.$i.'&amp;lang='.$language.'&amp;start='.$start.'">'.$lang['Edit'].'</a>]&nbsp;'."\n";
					echo '[<a href="'.$url.'?mode=delete&amp;id='.$i.'&amp;lang='.$language.'&amp;start='.$start.'">'.$lang['Delete'].'</a>]&nbsp;'."\n";
					echo '[<a href="'.$url.'?mode=parse&amp;id='.$i.'" target="_blank">'.$lang['Parse'].'</a>]'."\n";
					$m++;
				}
			}

			if (!$m)
			{
				echo '<br /><div align="center">'.$lang['No_files_found'].'</div>'."\n";
			}
		}
		else
		{
			echo '<br /><div align="center">'.$lang['No_files_found'].'</div>'."\n";
		}

		echo '<br /><br /><div align="center">[<a href="'.$url.'?mode=add&amp;lang='.$language.'&amp;start='.$start.'">'.$lang['Add'].'</a>]</div>'."\n";

		// Build the pagination, in needed
		$pagination = '';
		if (sizeof($index) > $page_rows)
		{
			$pages = ceil(sizeof($index) / $page_rows);
			for ($i = 1; $i <= $pages; $i++)
			{
				$pagination .= '&nbsp;<a href="'.$url.'?mode='.$mode.'&amp;lang='.$language.'&amp;start='.$page_rows * $i.'">'.$i.'</a>&nbsp;'."\n";
			}
			echo '<br /><div align="right">'.$lang['Page'] . $pagination.'</div>'."\n";
		}	
}

if (!empty($redirect))
{
	if (@preg_match('/Microsoft|WebSTAR|Xitami/', getenv('SERVER_SOFTWARE')))
	{
		header('Refresh: 0; URL=' . $url);
		echo	'<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
			<html>
			<head>
			<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
			<meta http-equiv="refresh" content="0; url=' . $url . '">
			<title>Redirect</title>
			</head>
			<body>
			<div align="center">If your browser does not support meta redirection please click <a href="' . $url . '">HERE</a> to be redirected</div>
			</body>
			</html>';
		exit;
	}
	else
	{
		header("HTTP/1.1 301 Moved Permanently");
		header('Location: ' . $url);
		exit;
	}
}

?>

<div align="center"><br /><br /><hr />Simple&nbsp;Editor&nbsp;&copy;&nbsp;2007&nbsp;<a href="http://www.oxpus.net">OXPUS</a></div>

</body>
</html>

<?php

exit;

?>